import * as React from 'react';
import { LinearProgressLabelAlign_$type } from "./LinearProgressLabelAlign";
import { IgrProgressBase } from "./igr-progress-base";
import { LinearProgress } from "./LinearProgress";
import { IgcLinearProgressComponent, defineComponents } from "igniteui-webcomponents";
import { ensureBool, ensureEnum } from "igniteui-react-core";
/**
 * A linear progress indicator used to express unspecified wait time or display
 * the length of a process.
*/
export class IgrLinearProgress extends IgrProgressBase {
    constructor(props) {
        super(props);
        this._getMainRef = this._getMainRef.bind(this);
        defineComponents(IgcLinearProgressComponent);
    }
    createImplementation() {
        return new LinearProgress();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    componentDidMount() {
        this.i.nativeElement = this._elRef;
        super.componentDidMount();
    }
    render() {
        let propChildren = this.props.children;
        let children = [];
        React.Children.forEach(propChildren, (ch) => {
            children.push(React.cloneElement(ch));
        });
        let div = React.createElement("igc-linear-progress", {
            ref: this._getMainRef,
            className: this.props.className,
            style: this.props.style,
            children: children
        });
        return div;
    }
    _getMainRef(ref) {
        this._elRef = ref;
    }
    /**
     * Sets the striped look of the control.
    */
    get striped() {
        return this.i.n;
    }
    set striped(v) {
        this.i.n = ensureBool(v);
    }
    /**
     * The position for the default label of the control.
    */
    get labelAlign() {
        return this.i.m;
    }
    set labelAlign(v) {
        this.i.m = ensureEnum(LinearProgressLabelAlign_$type, v);
    }
}
