import { PaneDragActionType_$type } from "./PaneDragActionType";
import { IgrPaneDragAction } from "./igr-pane-drag-action";
import { MoveFloatingPaneAction } from "./MoveFloatingPaneAction";
import { ensureEnum } from "igniteui-react-core";
export class IgrMoveFloatingPaneAction extends IgrPaneDragAction {
    createImplementation() {
        return new MoveFloatingPaneAction();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    get actionType() {
        return this.i.c;
    }
    set actionType(v) {
        this.i.c = ensureEnum(PaneDragActionType_$type, v);
    }
    get oldLocation() {
        if (this.i.b == null) {
            return null;
        }
        return this.i.b.externalObject;
    }
    set oldLocation(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.b = null : this.i.b = v.i;
    }
    get newLocation() {
        if (this.i.a == null) {
            return null;
        }
        return this.i.a.externalObject;
    }
    set newLocation(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.a = null : this.i.a = v.i;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.oldLocation && this.oldLocation.name && this.oldLocation.name == name) {
            return this.oldLocation;
        }
        if (this.newLocation && this.newLocation.name && this.newLocation.name == name) {
            return this.newLocation;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.oldLocation && this.oldLocation._styling) {
            this.oldLocation._styling(container, component, this);
        }
        if (this.newLocation && this.newLocation._styling) {
            this.newLocation._styling(container, component, this);
        }
        this._inStyling = false;
    }
}
