import * as React from 'react';
import { IgrCheckboxBase } from "./igr-checkbox-base";
import { Switch } from "./Switch";
import { IgcSwitchComponent, defineComponents } from "igniteui-webcomponents";
/**
 * Similar to a checkbox, a switch controls the state of a single setting on or off.
*/
export class IgrSwitch extends IgrCheckboxBase {
    constructor(props) {
        super(props);
        this._getMainRef = this._getMainRef.bind(this);
        defineComponents(IgcSwitchComponent);
    }
    createImplementation() {
        return new Switch();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    componentDidMount() {
        this.i.nativeElement = this._elRef;
        super.componentDidMount();
    }
    render() {
        let propChildren = this.props.children;
        let children = [];
        React.Children.forEach(propChildren, (ch) => {
            children.push(React.cloneElement(ch));
        });
        let div = React.createElement("igc-switch", {
            ref: this._getMainRef,
            className: this.props.className,
            style: this.props.style,
            children: children
        });
        return div;
    }
    _getMainRef(ref) {
        this._elRef = ref;
    }
}
