/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { DropdownPlacement_$type } from "./DropdownPlacement";
import { DropdownPositionStrategy_$type } from "./DropdownPositionStrategy";
import { DropdownScrollStrategy_$type } from "./DropdownScrollStrategy";
import { SizableComponentSize_$type } from "./SizableComponentSize";
import { DropdownItemComponentEventArgs } from "./DropdownItemComponentEventArgs";
/**
 * @hidden
 */
var Dropdown = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Dropdown, _super);
    function Dropdown() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.h = new WCNativeHelper();
        _this.p = null;
        _this.change = null;
        return _this;
    }
    Dropdown.prototype.v = function () {
        this.nativeElement.show();
    };
    Dropdown.prototype.x = function () {
        this.nativeElement.toggle();
    };
    Dropdown.prototype.showTarget = function (target_) {
        this.nativeElement.show(target_);
    };
    Dropdown.prototype.toggleTarget = function (target_) {
        this.nativeElement.toggle(target_);
    };
    Dropdown.prototype.a = function (a) {
        return (this.nativeElement.navigateTo(a));
    };
    Dropdown.prototype.b = function (a) {
        return (this.nativeElement.select(a));
    };
    Object.defineProperty(Dropdown.prototype, "i", {
        get: function () {
            return this.h;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Dropdown.prototype, "nativeElement", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            this.p = a;
            this.h.d = this.p;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Dropdown.prototype, "l", {
        get: function () {
            var ret_ = this.i.c("keepOpenOnSelect");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.i("keepOpenOnSelect", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Dropdown.prototype, "m", {
        get: function () {
            var ret_ = this.i.c("open");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.i("open", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Dropdown.prototype, "d", {
        get: function () {
            var ret_ = this.i.c("placement");
            ret_ = enumGetBox(DropdownPlacement_$type, EnumUtil.getEnumValue(DropdownPlacement_$type, EnumUtil.parse(DropdownPlacement_$type, ret_.toString(), true)));
            return EnumUtil.getEnumValue(DropdownPlacement_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(DropdownPlacement_$type, a);
            value_ = WCNativeHelper.e(value_.toString());
            this.i.i("placement", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Dropdown.prototype, "e", {
        get: function () {
            var ret_ = this.i.c("positionStrategy");
            ret_ = enumGetBox(DropdownPositionStrategy_$type, EnumUtil.getEnumValue(DropdownPositionStrategy_$type, EnumUtil.parse(DropdownPositionStrategy_$type, ret_.toString(), true)));
            return EnumUtil.getEnumValue(DropdownPositionStrategy_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(DropdownPositionStrategy_$type, a);
            value_ = WCNativeHelper.e(value_.toString());
            this.i.i("positionStrategy", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Dropdown.prototype, "f", {
        get: function () {
            var ret_ = this.i.c("scrollStrategy");
            ret_ = enumGetBox(DropdownScrollStrategy_$type, EnumUtil.getEnumValue(DropdownScrollStrategy_$type, EnumUtil.parse(DropdownScrollStrategy_$type, ret_.toString(), true)));
            return EnumUtil.getEnumValue(DropdownScrollStrategy_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(DropdownScrollStrategy_$type, a);
            value_ = WCNativeHelper.e(value_.toString());
            this.i.i("scrollStrategy", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Dropdown.prototype, "j", {
        get: function () {
            var ret_ = this.i.c("flip");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.i("flip", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Dropdown.prototype, "o", {
        get: function () {
            var ret_ = this.i.c("distance");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.i("distance", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Dropdown.prototype, "k", {
        get: function () {
            var ret_ = this.i.c("keepOpenOnOutsideClick");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.i("keepOpenOnOutsideClick", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Dropdown.prototype, "n", {
        get: function () {
            var ret_ = this.i.c("sameWidth");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.i("sameWidth", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Dropdown.prototype, "g", {
        get: function () {
            var ret_ = this.i.c("size");
            ret_ = enumGetBox(SizableComponentSize_$type, EnumUtil.getEnumValue(SizableComponentSize_$type, EnumUtil.parse(SizableComponentSize_$type, ret_.toString(), true)));
            return EnumUtil.getEnumValue(SizableComponentSize_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(SizableComponentSize_$type, a);
            value_ = WCNativeHelper.e(value_.toString());
            this.i.i("size", value_);
        },
        enumerable: false,
        configurable: true
    });
    Dropdown.prototype.changeChanged = function () {
        var _this = this;
        if (this.change != null) {
            this.i.g("change", function (a) { return _this.change(_this, DropdownItemComponentEventArgs.b(a)); });
        }
        else {
            this.i.h("change");
        }
    };
    Dropdown.prototype.t = function () {
        this.nativeElement.firstUpdated();
    };
    Dropdown.prototype.u = function () {
        this.nativeElement.hide();
    };
    Dropdown.prototype.s = function () {
        this.nativeElement.clearSelection();
    };
    Dropdown.$t = markType(Dropdown, 'Dropdown', BaseElement.$);
    return Dropdown;
}(BaseElement));
export { Dropdown };
