/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { TreeSelection_$type } from "./TreeSelection";
import { TreeDir_$type } from "./TreeDir";
import { SizableComponentSize_$type } from "./SizableComponentSize";
import { TreeSelectionOptionsEventArgs } from "./TreeSelectionOptionsEventArgs";
import { TreeItemComponentEventArgs } from "./TreeItemComponentEventArgs";
/**
 * @hidden
 */
var Tree = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Tree, _super);
    function Tree() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.j = new WCNativeHelper();
        _this.m = null;
        _this.selectionChanged = null;
        _this.itemExpanding = null;
        _this.itemExpanded = null;
        _this.itemCollapsing = null;
        _this.itemCollapsed = null;
        _this.activeItem = null;
        return _this;
    }
    Object.defineProperty(Tree.prototype, "k", {
        get: function () {
            return this.j;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Tree.prototype, "nativeElement", {
        get: function () {
            return this.m;
        },
        set: function (a) {
            this.m = a;
            this.j.d = this.m;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Tree.prototype, "l", {
        get: function () {
            var ret_ = this.k.c("singleBranchExpand");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.k.i("singleBranchExpand", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Tree.prototype, "h", {
        get: function () {
            var ret_ = this.k.c("selection");
            ret_ = enumGetBox(TreeSelection_$type, EnumUtil.getEnumValue(TreeSelection_$type, EnumUtil.parse(TreeSelection_$type, ret_.toString(), true)));
            return EnumUtil.getEnumValue(TreeSelection_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(TreeSelection_$type, a);
            value_ = WCNativeHelper.e(value_.toString());
            this.k.i("selection", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Tree.prototype, "b", {
        get: function () {
            var ret_ = this.k.c("dir");
            ret_ = enumGetBox(TreeDir_$type, EnumUtil.getEnumValue(TreeDir_$type, EnumUtil.parse(TreeDir_$type, ret_.toString(), true)));
            return EnumUtil.getEnumValue(TreeDir_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(TreeDir_$type, a);
            value_ = WCNativeHelper.e(value_.toString());
            this.k.i("dir", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Tree.prototype, "a", {
        get: function () {
            var ret_ = this.k.c("size");
            ret_ = enumGetBox(SizableComponentSize_$type, EnumUtil.getEnumValue(SizableComponentSize_$type, EnumUtil.parse(SizableComponentSize_$type, ret_.toString(), true)));
            return EnumUtil.getEnumValue(SizableComponentSize_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(SizableComponentSize_$type, a);
            value_ = WCNativeHelper.e(value_.toString());
            this.k.i("size", value_);
        },
        enumerable: false,
        configurable: true
    });
    Tree.prototype.selectionChangedChanged = function () {
        var _this = this;
        if (this.selectionChanged != null) {
            this.k.g("selection", function (a) { return _this.selectionChanged(_this, TreeSelectionOptionsEventArgs.a(a)); });
        }
        else {
            this.k.h("selection");
        }
    };
    Tree.prototype.itemExpandingChanged = function () {
        var _this = this;
        if (this.itemExpanding != null) {
            this.k.g("itemExpanding", function (a) { return _this.itemExpanding(_this, TreeItemComponentEventArgs.b(a)); });
        }
        else {
            this.k.h("itemExpanding");
        }
    };
    Tree.prototype.itemExpandedChanged = function () {
        var _this = this;
        if (this.itemExpanded != null) {
            this.k.g("itemExpanded", function (a) { return _this.itemExpanded(_this, TreeItemComponentEventArgs.b(a)); });
        }
        else {
            this.k.h("itemExpanded");
        }
    };
    Tree.prototype.itemCollapsingChanged = function () {
        var _this = this;
        if (this.itemCollapsing != null) {
            this.k.g("itemCollapsing", function (a) { return _this.itemCollapsing(_this, TreeItemComponentEventArgs.b(a)); });
        }
        else {
            this.k.h("itemCollapsing");
        }
    };
    Tree.prototype.itemCollapsedChanged = function () {
        var _this = this;
        if (this.itemCollapsed != null) {
            this.k.g("itemCollapsed", function (a) { return _this.itemCollapsed(_this, TreeItemComponentEventArgs.b(a)); });
        }
        else {
            this.k.h("itemCollapsed");
        }
    };
    Tree.prototype.activeItemChanged = function () {
        var _this = this;
        if (this.activeItem != null) {
            this.k.g("activeItem", function (a) { return _this.activeItem(_this, TreeItemComponentEventArgs.b(a)); });
        }
        else {
            this.k.h("activeItem");
        }
    };
    Tree.prototype.p = function () {
        this.nativeElement.connectedCallback();
    };
    Tree.prototype.q = function (a) {
        this.nativeElement.expandToItem(a);
    };
    Tree.$t = markType(Tree, 'Tree', BaseElement.$);
    return Tree;
}(BaseElement));
export { Tree };
