import { __extends } from "tslib";
import * as React from 'react';
import { IgrCheckboxBase } from "./igr-checkbox-base";
import { Switch } from "./Switch";
import { IgcSwitchComponent, defineComponents } from "igniteui-webcomponents";
/**
 * Similar to a checkbox, a switch controls the state of a single setting on or off.
*/
var IgrSwitch = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSwitch, _super);
    function IgrSwitch(props) {
        var _this = _super.call(this, props) || this;
        _this._getMainRef = _this._getMainRef.bind(_this);
        defineComponents(IgcSwitchComponent);
        return _this;
    }
    IgrSwitch.prototype.createImplementation = function () {
        return new Switch();
    };
    Object.defineProperty(IgrSwitch.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrSwitch.prototype.componentDidMount = function () {
        this.i.nativeElement = this._elRef;
        _super.prototype.componentDidMount.call(this);
    };
    IgrSwitch.prototype.render = function () {
        var propChildren = this.props.children;
        var children = [];
        React.Children.forEach(propChildren, function (ch) {
            children.push(React.cloneElement(ch));
        });
        var div = React.createElement("igc-switch", {
            ref: this._getMainRef,
            className: this.props.className,
            style: this.props.style,
            children: children
        });
        return div;
    };
    IgrSwitch.prototype._getMainRef = function (ref) {
        this._elRef = ref;
    };
    return IgrSwitch;
}(IgrCheckboxBase));
export { IgrSwitch };
