import * as React from 'react';
import { ButtonVariant } from "./ButtonVariant";
import { IgrButtonBase, IIgrButtonBaseProps } from "./igr-button-base";
import { Button } from "./Button";
/**
 * Represents a clickable button, used to submit forms or anywhere in a
 * document for accessible, standard button functionality.
*/
export declare class IgrButton extends IgrButtonBase<IIgrButtonProps> {
    protected createImplementation(): Button;
    /**
                                 * @hidden
                                 */
    get i(): Button;
    constructor(props: IIgrButtonProps);
    componentDidMount(): void;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: string;
        style: React.CSSProperties;
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * Sets the variant of the button.
    */
    get variant(): ButtonVariant;
    set variant(v: ButtonVariant);
}
export interface IIgrButtonProps extends IIgrButtonBaseProps {
    /**
     * Sets the variant of the button.
    */
    variant?: ButtonVariant | string;
}
