import * as React from 'react';
import { CardActionsOrientation } from "./CardActionsOrientation";
import { CardActions } from "./CardActions";
/**
 * A container for card action items like buttons
*/
export declare class IgrCardActions<P extends IIgrCardActionsProps = IIgrCardActionsProps> extends React.Component<P, {}> {
    protected createImplementation(): CardActions;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): CardActions; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrCardActions;
    private onImplementationCreated;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * The orientation of the actions.
    */
    get orientation(): CardActionsOrientation;
    set orientation(v: CardActionsOrientation);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
}
export interface IIgrCardActionsProps {
    children?: React.ReactNode;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    /**
     * The orientation of the actions.
    */
    orientation?: CardActionsOrientation | string;
}
