import * as React from 'react';
import { IgrCheckboxBase, IIgrCheckboxBaseProps } from "./igr-checkbox-base";
import { Checkbox } from "./Checkbox";
/**
 * A check box allowing single values to be selected/deselected.
*/
export declare class IgrCheckbox extends IgrCheckboxBase<IIgrCheckboxProps> {
    protected createImplementation(): Checkbox;
    /**
                                 * @hidden
                                 */
    get i(): Checkbox;
    constructor(props: IIgrCheckboxProps);
    componentDidMount(): void;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: string;
        style: React.CSSProperties;
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * Draws the checkbox in indeterminate state.
    */
    get indeterminate(): boolean;
    set indeterminate(v: boolean);
}
export interface IIgrCheckboxProps extends IIgrCheckboxBaseProps {
    /**
     * Draws the checkbox in indeterminate state.
    */
    indeterminate?: boolean | string;
}
