import * as React from 'react';
import { IgrSplitPane } from "./igr-split-pane";
import { IgrSplitPaneCollection } from "./igr-split-pane-collection";
import { DockManagerLayout } from "./DockManagerLayout";
/**
 * Describes a Dock Manager layout.
*/
export declare class IgrDockManagerLayout<P extends IIgrDockManagerLayoutProps = IIgrDockManagerLayoutProps> extends React.Component<P, {}> {
    protected createImplementation(): DockManagerLayout;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): DockManagerLayout; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrDockManagerLayout;
    private onImplementationCreated;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): any;
    /**
     * The root split pane of the layout.
    */
    get rootPane(): IgrSplitPane;
    set rootPane(v: IgrSplitPane);
    private _floatingPanes;
    /**
     * The floating panes of the layout.
    */
    get floatingPanes(): IgrSplitPaneCollection;
    set floatingPanes(v: IgrSplitPaneCollection);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
}
export interface IIgrDockManagerLayoutProps {
    children?: React.ReactNode;
    /**
     * The root split pane of the layout.
    */
    rootPane?: IgrSplitPane;
    /**
     * The floating panes of the layout.
    */
    floatingPanes?: IgrSplitPaneCollection | string;
}
