import { DockManagerPaneType } from "./DockManagerPaneType";
import { IgrSplitPane } from "./igr-split-pane";
import { IgrDockManagerPane, IIgrDockManagerPaneProps } from "./igr-dock-manager-pane";
import { DocumentHost } from "./DocumentHost";
export declare class IgrDocumentHost extends IgrDockManagerPane<IIgrDocumentHostProps> {
    protected createImplementation(): DocumentHost;
    /**
                                 * @hidden
                                 */
    get i(): DocumentHost;
    constructor(props: IIgrDocumentHostProps);
    /**
     * The id of the pane. If not set the Dock Manager generates it automatically.
    */
    get id(): string;
    set id(v: string);
    /**
     * The type of the pane.
    */
    get paneType(): DockManagerPaneType;
    set paneType(v: DockManagerPaneType);
    /**
     * The root split pane of the document host.
    */
    get rootPane(): IgrSplitPane;
    set rootPane(v: IgrSplitPane);
    /**
     * The size of the pane relative to its sibling panes' sizes. Defaults to 100.
    */
    get size(): number;
    set size(v: number);
    findByName(name: string): any;
    protected _styling(container: any, component: any, parent?: any): void;
}
export interface IIgrDocumentHostProps extends IIgrDockManagerPaneProps {
    /**
     * The id of the pane. If not set the Dock Manager generates it automatically.
    */
    id?: string;
    /**
     * The type of the pane.
    */
    paneType?: DockManagerPaneType | string;
    /**
     * The root split pane of the document host.
    */
    rootPane?: IgrSplitPane;
    /**
     * The size of the pane relative to its sibling panes' sizes. Defaults to 100.
    */
    size?: number | string;
}
