import * as React from 'react';
import { DropdownItem } from "./DropdownItem";
/**
 * Represents an item in a dropdown list.
*/
export declare class IgrDropdownItem<P extends IIgrDropdownItemProps = IIgrDropdownItemProps> extends React.Component<P, {}> {
    protected createImplementation(): DropdownItem;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): DropdownItem; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrDropdownItem;
    private onImplementationCreated;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    get value(): string;
    set value(v: string);
    /**
     * Determines whether the item is selected.
    */
    get selected(): boolean;
    set selected(v: boolean);
    /**
     * Determines whether the item is active.
    */
    get active(): boolean;
    set active(v: boolean);
    /**
     * Determines whether the item is disabled.
    */
    get disabled(): boolean;
    set disabled(v: boolean);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    connectedCallback(): void;
}
export interface IIgrDropdownItemProps {
    children?: React.ReactNode;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    value?: string;
    /**
     * Determines whether the item is selected.
    */
    selected?: boolean | string;
    /**
     * Determines whether the item is active.
    */
    active?: boolean | string;
    /**
     * Determines whether the item is disabled.
    */
    disabled?: boolean | string;
}
