import * as React from 'react';
import { IgrFormDataEventArgs } from "./igr-form-data-event-args";
import { IgrVoidEventArgs } from "./igr-void-event-args";
import { Form } from "./Form";
/**
 * The form is a component used to collect user input from
 * interactive controls.
*/
export declare class IgrForm<P extends IIgrFormProps = IIgrFormProps> extends React.Component<P, {}> {
    protected createImplementation(): Form;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): Form; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrForm;
    private onImplementationCreated;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * Specifies if form data validation should be skipped on submit.
    */
    get novalidate(): boolean;
    set novalidate(v: boolean);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
     * Submits the form.
    
    */
    performSubmit(): boolean;
    /**
     * Resets the form.
    
    */
    performReset(): void;
    /**
     * Checks for validity of the form.
    
    */
    reportValidity(): boolean;
    private _submit;
    private _submit_wrapped;
    get submit(): (s: IgrForm, e: IgrFormDataEventArgs) => void;
    set submit(ev: (s: IgrForm, e: IgrFormDataEventArgs) => void);
    private _reset;
    private _reset_wrapped;
    get reset(): (s: IgrForm, e: IgrVoidEventArgs) => void;
    set reset(ev: (s: IgrForm, e: IgrVoidEventArgs) => void);
}
export interface IIgrFormProps {
    children?: React.ReactNode;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    /**
     * Specifies if form data validation should be skipped on submit.
    */
    novalidate?: boolean | string;
    submit?: (s: IgrForm, e: IgrFormDataEventArgs) => void;
    reset?: (s: IgrForm, e: IgrVoidEventArgs) => void;
}
