import * as React from 'react';
import { ListItem } from "./ListItem";
/**
 * The list-item component is a container
 * intended for row items in the list component.
*/
export declare class IgrListItem<P extends IIgrListItemProps = IIgrListItemProps> extends React.Component<P, {}> {
    protected createImplementation(): ListItem;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): ListItem; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrListItem;
    private onImplementationCreated;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    connectedCallback(): void;
}
export interface IIgrListItemProps {
    children?: React.ReactNode;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
}
