import * as React from 'react';
import { Navbar } from "./Navbar";
/**
 * A navigation bar component is used to facilitate navigation through
 * a series of hierarchical screens within an app.
*/
export declare class IgrNavbar<P extends IIgrNavbarProps = IIgrNavbarProps> extends React.Component<P, {}> {
    protected createImplementation(): Navbar;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): Navbar; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrNavbar;
    private onImplementationCreated;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
}
export interface IIgrNavbarProps {
    children?: React.ReactNode;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
}
