import * as React from 'react';
import { RadioLabelPosition } from "./RadioLabelPosition";
import { IgrComponentBoolValueChangedEventArgs } from "./igr-component-bool-value-changed-event-args";
import { IgrVoidEventArgs } from "./igr-void-event-args";
import { IgrFocusOptions } from "./igr-focus-options";
import { Radio } from "./Radio";
/**

*/
export declare class IgrRadio<P extends IIgrRadioProps = IIgrRadioProps> extends React.Component<P, {}> {
    protected createImplementation(): Radio;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): Radio; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrRadio;
    private onImplementationCreated;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * The name attribute of the control.
    */
    get name(): string;
    set name(v: string);
    /**
     * The value attribute of the control.
    */
    get value(): string;
    set value(v: string);
    /**
     * Makes the control a required field.
    */
    get required(): boolean;
    set required(v: boolean);
    /**
     * The checked state of the control.
    */
    get checked(): boolean;
    set checked(v: boolean);
    /**
     * Disables the radio control.
    */
    get disabled(): boolean;
    set disabled(v: boolean);
    /**
     * Controls the validity of the control.
    */
    get invalid(): boolean;
    set invalid(v: boolean);
    /**
     * The label position of the radio control.
    */
    get labelPosition(): RadioLabelPosition;
    set labelPosition(v: RadioLabelPosition);
    /**
     * Sets the aria-labelledby attribute for the radio control.
    */
    get ariaLabelledby(): string;
    set ariaLabelledby(v: string);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
     * Simulates a click on the radio control.
    
    */
    click(): void;
    connectedCallback(): void;
    disconnectedCallback(): void;
    /**
     * Sets focus on the radio control.
    
    */
    focusComponent(options: IgrFocusOptions): void;
    /**
     * Removes focus from the radio control.
    
    */
    blurComponent(): void;
    /**
     * Checks for validity of the control and shows the browser message if it invalid.
    
    */
    reportValidity(): void;
    /**
     * Sets a custom validation message for the control.
     * As long as `message` is not empty, the control is considered invalid.
    
    */
    setCustomValidity(message: string): void;
    private _change;
    private _change_wrapped;
    get change(): (s: IgrRadio, e: IgrComponentBoolValueChangedEventArgs) => void;
    set change(ev: (s: IgrRadio, e: IgrComponentBoolValueChangedEventArgs) => void);
    private _focus;
    private _focus_wrapped;
    get focus(): (s: IgrRadio, e: IgrVoidEventArgs) => void;
    set focus(ev: (s: IgrRadio, e: IgrVoidEventArgs) => void);
    private _blur;
    private _blur_wrapped;
    get blur(): (s: IgrRadio, e: IgrVoidEventArgs) => void;
    set blur(ev: (s: IgrRadio, e: IgrVoidEventArgs) => void);
}
export interface IIgrRadioProps {
    children?: React.ReactNode;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    /**
     * The name attribute of the control.
    */
    name?: string;
    /**
     * The value attribute of the control.
    */
    value?: string;
    /**
     * Makes the control a required field.
    */
    required?: boolean | string;
    /**
     * The checked state of the control.
    */
    checked?: boolean | string;
    /**
     * Disables the radio control.
    */
    disabled?: boolean | string;
    /**
     * Controls the validity of the control.
    */
    invalid?: boolean | string;
    /**
     * The label position of the radio control.
    */
    labelPosition?: RadioLabelPosition | string;
    /**
     * Sets the aria-labelledby attribute for the radio control.
    */
    ariaLabelledby?: string;
    change?: (s: IgrRadio, e: IgrComponentBoolValueChangedEventArgs) => void;
    focus?: (s: IgrRadio, e: IgrVoidEventArgs) => void;
    blur?: (s: IgrRadio, e: IgrVoidEventArgs) => void;
}
