import * as React from 'react';
import { RatingSymbol } from "./RatingSymbol";
/**
 * Used when a custom icon/symbol/element needs to be passed to the igc-rating component.
*/
export declare class IgrRatingSymbol<P extends IIgrRatingSymbolProps = IIgrRatingSymbolProps> extends React.Component<P, {}> {
    protected createImplementation(): RatingSymbol;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): RatingSymbol; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrRatingSymbol;
    private onImplementationCreated;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
}
export interface IIgrRatingSymbolProps {
    children?: React.ReactNode;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
}
