import * as React from 'react';
import { Ripple } from "./Ripple";
/**
 * A ripple can be applied to an element to represent
 * interactive surface.
*/
export declare class IgrRipple<P extends IIgrRippleProps = IIgrRippleProps> extends React.Component<P, {}> {
    protected createImplementation(): Ripple;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): Ripple; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrRipple;
    private onImplementationCreated;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
}
export interface IIgrRippleProps {
    children?: React.ReactNode;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
}
