import * as React from 'react';
import { SliderBaseTickOrientation } from "./SliderBaseTickOrientation";
import { NumberFormatOptions } from "./NumberFormatOptions";
import { TickLabelRotation } from "./TickLabelRotation";
import { SliderBase } from "./SliderBase";
export declare class IgrSliderBase<P extends IIgrSliderBaseProps = IIgrSliderBaseProps> extends React.Component<P, {}> {
    protected createImplementation(): SliderBase;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): SliderBase; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrSliderBase;
    private onImplementationCreated;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        className: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    get min(): number;
    set min(v: number);
    get max(): number;
    set max(v: number);
    get lowerBound(): number;
    set lowerBound(v: number);
    get upperBound(): number;
    set upperBound(v: number);
    /**
     * Disables the UI interactions of the slider.
    */
    get disabled(): boolean;
    set disabled(v: boolean);
    /**
     * Marks the slider track as discrete so it displays the steps.
     * If the `step` is 0, the slider will remain continuos even if `discreteTrack` is `true`.
    */
    get discreteTrack(): boolean;
    set discreteTrack(v: boolean);
    /**
     * Hides the thumb tooltip.
    */
    get hideTooltip(): boolean;
    set hideTooltip(v: boolean);
    get step(): number;
    set step(v: number);
    /**
     * The number of primary ticks. It defaults to 0 which means no primary ticks are displayed.
    */
    get primaryTicks(): number;
    set primaryTicks(v: number);
    /**
     * The number of secondary ticks. It defaults to 0 which means no secondary ticks are displayed.
    */
    get secondaryTicks(): number;
    set secondaryTicks(v: number);
    /**
     * Changes the orientation of the ticks.
    */
    get tickOrientation(): SliderBaseTickOrientation;
    set tickOrientation(v: SliderBaseTickOrientation);
    /**
     * Hides the primary tick labels.
    */
    get hidePrimaryLabels(): boolean;
    set hidePrimaryLabels(v: boolean);
    /**
     * Hides the secondary tick labels.
    */
    get hideSecondaryLabels(): boolean;
    set hideSecondaryLabels(v: boolean);
    /**
     * The locale used to format the thumb and tick label values in the slider.
    */
    get locale(): string;
    set locale(v: string);
    /**
     * String format used for the thumb and tick label values in the slider.
    */
    get valueFormat(): string;
    set valueFormat(v: string);
    /**
     * Number format options used for the thumb and tick label values in the slider.
    */
    get valueFormatOptions(): NumberFormatOptions;
    set valueFormatOptions(v: NumberFormatOptions);
    /**
     * The degrees for the rotation of the tick labels. Defaults to 0.
    */
    get tickLabelRotation(): TickLabelRotation;
    set tickLabelRotation(v: TickLabelRotation);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    connectedCallback(): void;
}
export interface IIgrSliderBaseProps {
    children?: React.ReactNode;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    min?: number | string;
    max?: number | string;
    lowerBound?: number | string;
    upperBound?: number | string;
    /**
     * Disables the UI interactions of the slider.
    */
    disabled?: boolean | string;
    /**
     * Marks the slider track as discrete so it displays the steps.
     * If the `step` is 0, the slider will remain continuos even if `discreteTrack` is `true`.
    */
    discreteTrack?: boolean | string;
    /**
     * Hides the thumb tooltip.
    */
    hideTooltip?: boolean | string;
    step?: number | string;
    /**
     * The number of primary ticks. It defaults to 0 which means no primary ticks are displayed.
    */
    primaryTicks?: number | string;
    /**
     * The number of secondary ticks. It defaults to 0 which means no secondary ticks are displayed.
    */
    secondaryTicks?: number | string;
    /**
     * Changes the orientation of the ticks.
    */
    tickOrientation?: SliderBaseTickOrientation | string;
    /**
     * Hides the primary tick labels.
    */
    hidePrimaryLabels?: boolean | string;
    /**
     * Hides the secondary tick labels.
    */
    hideSecondaryLabels?: boolean | string;
    /**
     * The locale used to format the thumb and tick label values in the slider.
    */
    locale?: string;
    /**
     * String format used for the thumb and tick label values in the slider.
    */
    valueFormat?: string;
    /**
     * Number format options used for the thumb and tick label values in the slider.
    */
    valueFormatOptions?: NumberFormatOptions;
    /**
     * The degrees for the rotation of the tick labels. Defaults to 0.
    */
    tickLabelRotation?: TickLabelRotation | string;
}
