import { DockManagerPaneType } from "./DockManagerPaneType";
import { IgrContentPaneCollection } from "./igr-content-pane-collection";
import { IgrDockManagerPane, IIgrDockManagerPaneProps } from "./igr-dock-manager-pane";
import { TabGroupPane } from "./TabGroupPane";
export declare class IgrTabGroupPane extends IgrDockManagerPane<IIgrTabGroupPaneProps> {
    protected createImplementation(): TabGroupPane;
    /**
                                 * @hidden
                                 */
    get i(): TabGroupPane;
    constructor(props: IIgrTabGroupPaneProps);
    /**
     * The id of the pane. If not set the Dock Manager generates it automatically.
    */
    get id(): string;
    set id(v: string);
    /**
     * The type of the pane.
    */
    get paneType(): DockManagerPaneType;
    set paneType(v: DockManagerPaneType);
    private _panes;
    /**
     * The child content panes of the tab group.
    */
    get panes(): IgrContentPaneCollection;
    set panes(v: IgrContentPaneCollection);
    /**
     * The size of the pane relative to its sibling panes' sizes. Defaults to 100.
    */
    get size(): number;
    set size(v: number);
    /**
     * The index of the selected tab.
    */
    get selectedIndex(): number;
    set selectedIndex(v: number);
    /**
     * Determines whether the pane should present in the UI when empty.
    */
    get allowEmpty(): boolean;
    set allowEmpty(v: boolean);
    findByName(name: string): any;
}
export interface IIgrTabGroupPaneProps extends IIgrDockManagerPaneProps {
    /**
     * The id of the pane. If not set the Dock Manager generates it automatically.
    */
    id?: string;
    /**
     * The type of the pane.
    */
    paneType?: DockManagerPaneType | string;
    /**
     * The child content panes of the tab group.
    */
    panes?: IgrContentPaneCollection | string;
    /**
     * The size of the pane relative to its sibling panes' sizes. Defaults to 100.
    */
    size?: number | string;
    /**
     * The index of the selected tab.
    */
    selectedIndex?: number | string;
    /**
     * Determines whether the pane should present in the UI when empty.
    */
    allowEmpty?: boolean | string;
}
