import * as React from 'react';
import { DockingIndicatorPosition } from "./DockingIndicatorPosition";
import { DockingIndicator } from "./DockingIndicator";
export declare class IgrDockingIndicator<P extends IIgrDockingIndicatorProps = IIgrDockingIndicatorProps> extends React.Component<P, {}> {
    protected createImplementation(): DockingIndicator;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): DockingIndicator; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrDockingIndicator;
    private onImplementationCreated;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): any;
    /**
     * Gets the position of the docking indicator.
    */
    get position(): DockingIndicatorPosition;
    set position(v: DockingIndicatorPosition);
    /**
     * Gets a value indicating whether the docking indicator is a root one.
    */
    get isRoot(): boolean;
    set isRoot(v: boolean);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
}
export interface IIgrDockingIndicatorProps {
    children?: React.ReactNode;
    /**
     * Gets the position of the docking indicator.
    */
    position?: DockingIndicatorPosition | string;
    /**
     * Gets a value indicating whether the docking indicator is a root one.
    */
    isRoot?: boolean | string;
}
